# Gemini Streaming Content Generation

> Large Language Models

Generates a streamed response from the model given an input `GenerateContentRequest`.

## Endpoint

`POST https://api.modelverse.cn/v1beta/models/{modelsId}:streamGenerateContent`

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| modelsId | path | string | Yes | Required. The name of the `Model` to use for generating the completion. Format: `models/{model}`. Original Discovery parameter: `model`. |
| callback | query | string | No | JSONP |
| fields | query | string | No | Selector specifying which fields to include in a partial response. |
| prettyPrint | query | boolean | No | Returns response with indentations and line breaks. |
| quotaUser | query | string | No | Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. |
| $.xgafv | query | string | No | V1 error format. |
| alt | query | string | No | Data format for response. |
| upload_protocol | query | string | No | Upload protocol for media (e.g. "raw", "multipart"). |
| uploadType | query | string | No | Legacy upload protocol for media (e.g. "media", "multipart"). |

## Request Body

## Responses

- **200** — Successful response.
- **4XX** — Client error response.
- **default** — Error response.

## OpenAPI Definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "Gemini API v1beta Generate Content",
    "version": "v1beta",
    "description": "OpenAPI subset generated from the Gemini API Discovery document. This file keeps only v1beta models.generateContent and models.streamGenerateContent endpoints."
  },
  "servers": [
    {
      "url": "https://api.modelverse.cn",
      "description": "中国大陆节点，国内用户推荐，访问延迟低。"
    },
    {
      "url": "https://api-sg.umodelverse.ai",
      "description": "新加坡节点，东南亚用户推荐，访问更快。"
    },
    {
      "url": "https://api-us-ca.umodelverse.ai",
      "description": "美国洛杉矶节点，海外用户推荐，数据不回国。"
    },
    {
      "url": "https://api-ge-fra.umodelverse.ai",
      "description": "法兰克福节点，欧洲用户推荐，访问更快。"
    }
  ],
  "tags": [
    {
      "name": "models",
      "description": "Gemini model content generation operations."
    }
  ],
  "security": [
    {
      "xGoogApiKey": []
    }
  ],
  "paths": {
    "/v1beta/models/{modelsId}:streamGenerateContent": {
      "post": {
        "tags": [
          "models"
        ],
        "operationId": "generativelanguage.models.streamGenerateContent",
        "summary": "Gemini Streaming Content Generation",
        "description": "Generates a streamed response from the model given an input `GenerateContentRequest`.",
        "parameters": [
          {
            "name": "modelsId",
            "in": "path",
            "required": true,
            "description": "Required. The name of the `Model` to use for generating the completion. Format: `models/{model}`.\n\nOriginal Discovery parameter: `model`.",
            "schema": {
              "type": "string",
              "pattern": "^models/[^/]+$"
            },
            "x-original-parameter": {
              "name": "model",
              "required": true,
              "type": "string",
              "pattern": "^models/[^/]+$",
              "description": "Required. The name of the `Model` to use for generating the completion. Format: `models/{model}`.",
              "location": "path"
            }
          },
          {
            "name": "callback",
            "in": "query",
            "required": false,
            "description": "JSONP",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "fields",
            "in": "query",
            "required": false,
            "description": "Selector specifying which fields to include in a partial response.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "prettyPrint",
            "in": "query",
            "required": false,
            "description": "Returns response with indentations and line breaks.",
            "schema": {
              "type": "boolean",
              "default": "true"
            }
          },
          {
            "name": "quotaUser",
            "in": "query",
            "required": false,
            "description": "Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "$.xgafv",
            "in": "query",
            "required": false,
            "description": "V1 error format.",
            "schema": {
              "type": "string",
              "enum": [
                "1",
                "2"
              ],
              "x-enumDescriptions": [
                "v1 error format",
                "v2 error format"
              ]
            }
          },
          {
            "name": "alt",
            "in": "query",
            "required": false,
            "description": "Data format for response.",
            "schema": {
              "type": "string",
              "default": "json",
              "enum": [
                "json",
                "media",
                "proto"
              ],
              "x-enumDescriptions": [
                "Responses with Content-Type of application/json",
                "Media download with context-dependent Content-Type",
                "Responses with Content-Type of application/x-protobuf"
              ]
            }
          },
          {
            "name": "upload_protocol",
            "in": "query",
            "required": false,
            "description": "Upload protocol for media (e.g. \"raw\", \"multipart\").",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uploadType",
            "in": "query",
            "required": false,
            "description": "Legacy upload protocol for media (e.g. \"media\", \"multipart\").",
            "schema": {
              "type": "string"
            }
          }
        ],
        "security": [
          {
            "xGoogApiKey": []
          }
        ],
        "x-discovery-method": "generativelanguage.models.streamGenerateContent",
        "x-original-path": "v1beta/{+model}:streamGenerateContent",
        "x-flat-path": "v1beta/models/{modelsId}:streamGenerateContent",
        "x-parameterOrder": [
          "model"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/GenerateContentRequest"
              },
              "example": {
                "contents": [
                  {
                    "role": "user",
                    "parts": [
                      {
                        "text": "用一句话介绍 ModelVerse。"
                      }
                    ]
                  }
                ]
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GenerateContentResponse"
                },
                "example": {
                  "candidates": [
                    {
                      "content": {
                        "role": "model",
                        "parts": [
                          {
                            "text": "ModelVerse 是一个模型服务平台。"
                          }
                        ]
                      },
                      "finishReason": "STOP"
                    }
                  ],
                  "usageMetadata": {
                    "promptTokenCount": 8,
                    "candidatesTokenCount": 12,
                    "totalTokenCount": 20
                  }
                }
              }
            }
          },
          "4XX": {
            "description": "Client error response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Status"
                }
              }
            }
          },
          "default": {
            "description": "Error response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Status"
                }
              }
            }
          }
        }
      }
    },
    "/v1beta/models/{modelsId}:generateContent": {
      "post": {
        "tags": [
          "models"
        ],
        "operationId": "generativelanguage.models.generateContent",
        "summary": "Gemini Content Generation",
        "description": "Generates a model response given an input `GenerateContentRequest`. Input capabilities differ between models, including tuned models.",
        "parameters": [
          {
            "name": "modelsId",
            "in": "path",
            "required": true,
            "description": "Required. The name of the `Model` to use for generating the completion. Format: `models/{model}`.\n\nOriginal Discovery parameter: `model`.",
            "schema": {
              "type": "string",
              "pattern": "^models/[^/]+$"
            },
            "x-original-parameter": {
              "name": "model",
              "type": "string",
              "required": true,
              "description": "Required. The name of the `Model` to use for generating the completion. Format: `models/{model}`.",
              "location": "path",
              "pattern": "^models/[^/]+$"
            }
          },
          {
            "name": "callback",
            "in": "query",
            "required": false,
            "description": "JSONP",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "fields",
            "in": "query",
            "required": false,
            "description": "Selector specifying which fields to include in a partial response.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "prettyPrint",
            "in": "query",
            "required": false,
            "description": "Returns response with indentations and line breaks.",
            "schema": {
              "type": "boolean",
              "default": "true"
            }
          },
          {
            "name": "quotaUser",
            "in": "query",
            "required": false,
            "description": "Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "$.xgafv",
            "in": "query",
            "required": false,
            "description": "V1 error format.",
            "schema": {
              "type": "string",
              "enum": [
                "1",
                "2"
              ],
              "x-enumDescriptions": [
                "v1 error format",
                "v2 error format"
              ]
            }
          },
          {
            "name": "alt",
            "in": "query",
            "required": false,
            "description": "Data format for response.",
            "schema": {
              "type": "string",
              "default": "json",
              "enum": [
                "json",
                "media",
                "proto"
              ],
              "x-enumDescriptions": [
                "Responses with Content-Type of application/json",
                "Media download with context-dependent Content-Type",
                "Responses with Content-Type of application/x-protobuf"
              ]
            }
          },
          {
            "name": "upload_protocol",
            "in": "query",
            "required": false,
            "description": "Upload protocol for media (e.g. \"raw\", \"multipart\").",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "uploadType",
            "in": "query",
            "required": false,
            "description": "Legacy upload protocol for media (e.g. \"media\", \"multipart\").",
            "schema": {
              "type": "string"
            }
          }
        ],
        "security": [
          {
            "xGoogApiKey": []
          }
        ],
        "x-discovery-method": "generativelanguage.models.generateContent",
        "x-original-path": "v1beta/{+model}:generateContent",
        "x-flat-path": "v1beta/models/{modelsId}:generateContent",
        "x-parameterOrder": [
          "model"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/GenerateContentRequest"
              },
              "example": {
                "contents": [
                  {
                    "role": "user",
                    "parts": [
                      {
                        "text": "用一句话介绍 ModelVerse。"
                      }
                    ]
                  }
                ]
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Successful response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GenerateContentResponse"
                },
                "example": {
                  "candidates": [
                    {
                      "content": {
                        "role": "model",
                        "parts": [
                          {
                            "text": "ModelVerse 是一个模型服务平台。"
                          }
                        ]
                      },
                      "finishReason": "STOP"
                    }
                  ],
                  "usageMetadata": {
                    "promptTokenCount": 8,
                    "candidatesTokenCount": 12,
                    "totalTokenCount": 20
                  }
                }
              }
            }
          },
          "4XX": {
            "description": "Client error response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Status"
                }
              }
            }
          },
          "default": {
            "description": "Error response.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Status"
                }
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "securitySchemes": {
      "xGoogApiKey": {
        "type": "apiKey",
        "in": "header",
        "name": "x-goog-api-key",
        "description": "Gemini-compatible API key header."
      }
    },
    "schemas": {
      "AttributionSourceId": {
        "description": "Identifier for the source contributing to this attribution.",
        "x-discovery-id": "AttributionSourceId",
        "type": "object",
        "properties": {
          "groundingPassage": {
            "$ref": "#/components/schemas/GroundingPassageId"
          },
          "semanticRetrieverChunk": {
            "$ref": "#/components/schemas/SemanticRetrieverChunk"
          }
        }
      },
      "AudioResponseFormat": {
        "description": "Configuration for audio output format.",
        "x-discovery-id": "AudioResponseFormat",
        "type": "object",
        "properties": {
          "mimeType": {
            "description": "Optional. The MIME type of the audio output.",
            "type": "string",
            "enum": [
              "MIME_TYPE_UNSPECIFIED",
              "AUDIO_MP3",
              "AUDIO_OGG_OPUS",
              "AUDIO_L16",
              "AUDIO_WAV",
              "AUDIO_ALAW",
              "AUDIO_MULAW"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "MP3 audio format.",
              "OGG Opus audio format.",
              "Raw PCM (L16) audio format.",
              "WAV audio format.",
              "A-law audio format.",
              "Mu-law audio format."
            ]
          },
          "delivery": {
            "description": "Optional. The delivery mode for the audio output.",
            "type": "string",
            "enum": [
              "DELIVERY_UNSPECIFIED",
              "INLINE",
              "URI"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "Audio data is returned inline in the response.",
              "Audio data is returned as a URI."
            ]
          },
          "sampleRate": {
            "description": "Optional. Sample rate in Hz.",
            "type": "integer",
            "format": "int32"
          },
          "bitRate": {
            "description": "Optional. Bit rate in bits per second (bps). Only applicable for compressed formats (MP3, Opus).",
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "Blob": {
        "description": "Raw media bytes. Text should not be sent as raw bytes, use the 'text' field.",
        "x-discovery-id": "Blob",
        "type": "object",
        "properties": {
          "mimeType": {
            "description": "The IANA standard MIME type of the source data. Examples of supported types: - Images: image/png, image/jpeg, image/jpg, image/webp, image/heic, image/heif, image/gif, image/avif - Audio: audio/*, video/audio/s16le, video/audio/wav - Video: video/* - Text: text/plain, text/html, text/css, text/javascript, text/x-typescript, text/csv, text/markdown, text/x-python, text/xml, text/rtf, video/text/timestamp - Applications: application/x-javascript, application/x-typescript, application/x-python-code, application/json, application/x-ipynb+json, application/rtf, application/pdf For additional context, see [Supported file formats](https://ai.google.dev/gemini-api/docs/file-input-methods#supported-content-types). //",
            "type": "string"
          },
          "data": {
            "description": "Raw bytes for media formats.",
            "type": "string",
            "format": "byte"
          }
        }
      },
      "Candidate": {
        "description": "A response candidate generated from the model.",
        "x-discovery-id": "Candidate",
        "type": "object",
        "properties": {
          "citationMetadata": {
            "$ref": "#/components/schemas/CitationMetadata"
          },
          "finishReason": {
            "description": "Optional. Output only. The reason why the model stopped generating tokens. If empty, the model has not stopped generating tokens.",
            "readOnly": true,
            "type": "string",
            "enum": [
              "FINISH_REASON_UNSPECIFIED",
              "STOP",
              "MAX_TOKENS",
              "SAFETY",
              "RECITATION",
              "LANGUAGE",
              "OTHER",
              "BLOCKLIST",
              "PROHIBITED_CONTENT",
              "SPII",
              "MALFORMED_FUNCTION_CALL",
              "IMAGE_SAFETY",
              "IMAGE_PROHIBITED_CONTENT",
              "IMAGE_OTHER",
              "NO_IMAGE",
              "IMAGE_RECITATION",
              "UNEXPECTED_TOOL_CALL",
              "TOO_MANY_TOOL_CALLS",
              "MISSING_THOUGHT_SIGNATURE",
              "MALFORMED_RESPONSE",
              "ESCALATION"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "Natural stop point of the model or provided stop sequence.",
              "The maximum number of tokens as specified in the request was reached.",
              "The response candidate content was flagged for safety reasons.",
              "The response candidate content was flagged for recitation reasons.",
              "The response candidate content was flagged for using an unsupported language.",
              "Unknown reason.",
              "Token generation stopped because the content contains forbidden terms.",
              "Token generation stopped for potentially containing prohibited content.",
              "Token generation stopped because the content potentially contains Sensitive Personally Identifiable Information (SPII).",
              "The function call generated by the model is invalid.",
              "Token generation stopped because generated images contain safety violations.",
              "Image generation stopped because generated images has other prohibited content.",
              "Image generation stopped because of other miscellaneous issue.",
              "The model was expected to generate an image, but none was generated.",
              "Image generation stopped due to recitation.",
              "Model generated a tool call but no tools were enabled in the request.",
              "Model called too many tools consecutively, thus the system exited execution.",
              "Request has at least one thought signature missing.",
              "Finished due to malformed response.",
              "Request was filtered by an escalation rule."
            ]
          },
          "groundingMetadata": {
            "$ref": "#/components/schemas/GroundingMetadata"
          },
          "logprobsResult": {
            "$ref": "#/components/schemas/LogprobsResult"
          },
          "safetyRatings": {
            "description": "List of ratings for the safety of a response candidate. There is at most one rating per category.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SafetyRating"
            }
          },
          "content": {
            "$ref": "#/components/schemas/Content"
          },
          "tokenCount": {
            "description": "Output only. Token count for this candidate.",
            "readOnly": true,
            "type": "integer",
            "format": "int32"
          },
          "index": {
            "description": "Output only. Index of the candidate in the list of response candidates.",
            "readOnly": true,
            "type": "integer",
            "format": "int32"
          },
          "avgLogprobs": {
            "description": "Output only. Average log probability score of the candidate.",
            "readOnly": true,
            "type": "number",
            "format": "double"
          },
          "finishMessage": {
            "description": "Optional. Output only. Details the reason why the model stopped generating tokens. This is populated only when `finish_reason` is set.",
            "readOnly": true,
            "type": "string"
          },
          "groundingAttributions": {
            "description": "Output only. Attribution information for sources that contributed to a grounded answer. This field is populated for `GenerateAnswer` calls.",
            "readOnly": true,
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/GroundingAttribution"
            }
          },
          "urlContextMetadata": {
            "$ref": "#/components/schemas/UrlContextMetadata"
          }
        }
      },
      "CitationMetadata": {
        "description": "A collection of source attributions for a piece of content.",
        "x-discovery-id": "CitationMetadata",
        "type": "object",
        "properties": {
          "citationSources": {
            "description": "Citations to sources for a specific response.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/CitationSource"
            }
          }
        }
      },
      "CitationSource": {
        "description": "A citation to a source for a portion of a specific response.",
        "x-discovery-id": "CitationSource",
        "type": "object",
        "properties": {
          "startIndex": {
            "description": "Optional. Start of segment of the response that is attributed to this source. Index indicates the start of the segment, measured in bytes.",
            "type": "integer",
            "format": "int32"
          },
          "uri": {
            "description": "Optional. URI that is attributed as a source for a portion of the text.",
            "type": "string"
          },
          "license": {
            "description": "Optional. License for the GitHub project that is attributed as a source for segment. License info is required for code citations.",
            "type": "string"
          },
          "endIndex": {
            "description": "Optional. End of the attributed segment, exclusive.",
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "CodeExecution": {
        "description": "Tool that executes code generated by the model, and automatically returns the result to the model. See also `ExecutableCode` and `CodeExecutionResult` which are only generated when using this tool.",
        "x-discovery-id": "CodeExecution",
        "type": "object",
        "properties": {}
      },
      "CodeExecutionResult": {
        "description": "Result of executing the `ExecutableCode`. Generated only when the `CodeExecution` tool is used.",
        "x-discovery-id": "CodeExecutionResult",
        "type": "object",
        "properties": {
          "outcome": {
            "description": "Required. Outcome of the code execution.",
            "type": "string",
            "enum": [
              "OUTCOME_UNSPECIFIED",
              "OUTCOME_OK",
              "OUTCOME_FAILED",
              "OUTCOME_DEADLINE_EXCEEDED"
            ],
            "x-enumDescriptions": [
              "Unspecified status. This value should not be used.",
              "Code execution completed successfully. `output` contains the stdout, if any.",
              "Code execution failed. `output` contains the stderr and stdout, if any.",
              "Code execution ran for too long, and was cancelled. There may or may not be a partial `output` present."
            ]
          },
          "id": {
            "description": "Optional. The identifier of the `ExecutableCode` part this result is for. Only populated if the corresponding `ExecutableCode` has an id.",
            "type": "string"
          },
          "output": {
            "description": "Optional. Contains stdout when code execution is successful, stderr or other description otherwise.",
            "type": "string"
          }
        }
      },
      "ComputerUse": {
        "description": "Computer Use tool type.",
        "x-discovery-id": "ComputerUse",
        "type": "object",
        "properties": {
          "enablePromptInjectionDetection": {
            "description": "Optional. Whether enable the prompt injection detection check on computer-use request.",
            "type": "boolean"
          },
          "environment": {
            "description": "Required. The environment being operated.",
            "type": "string",
            "enum": [
              "ENVIRONMENT_UNSPECIFIED",
              "ENVIRONMENT_BROWSER",
              "ENVIRONMENT_MOBILE",
              "ENVIRONMENT_DESKTOP"
            ],
            "x-enumDescriptions": [
              "Defaults to browser.",
              "Operates in a web browser.",
              "Operates in a mobile environment.",
              "Operates in a desktop environment."
            ]
          },
          "excludedPredefinedFunctions": {
            "description": "Optional. By default, predefined functions are included in the final model call. Some of them can be explicitly excluded from being automatically included. This can serve two purposes: 1. Using a more restricted / different action space. 2. Improving the definitions / instructions of predefined functions.",
            "type": "array",
            "items": {
              "type": "string"
            }
          }
        }
      },
      "Content": {
        "description": "The base structured datatype containing multi-part content of a message. A `Content` includes a `role` field designating the producer of the `Content` and a `parts` field containing multi-part data that contains the content of the message turn.",
        "x-discovery-id": "Content",
        "type": "object",
        "properties": {
          "parts": {
            "description": "Ordered `Parts` that constitute a single message. Parts may have different MIME types.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Part"
            }
          },
          "role": {
            "description": "Optional. The producer of the content. Must be either 'user' or 'model'. Useful to set for multi-turn conversations, otherwise can be left blank or unset.",
            "type": "string"
          }
        }
      },
      "DynamicRetrievalConfig": {
        "description": "Describes the options to customize dynamic retrieval.",
        "x-discovery-id": "DynamicRetrievalConfig",
        "type": "object",
        "properties": {
          "mode": {
            "description": "The mode of the predictor to be used in dynamic retrieval.",
            "type": "string",
            "enum": [
              "MODE_UNSPECIFIED",
              "MODE_DYNAMIC"
            ],
            "x-enumDescriptions": [
              "Always trigger retrieval.",
              "Run retrieval only when system decides it is necessary."
            ]
          },
          "dynamicThreshold": {
            "description": "The threshold to be used in dynamic retrieval. If not set, a system default value is used.",
            "type": "number",
            "format": "float"
          }
        }
      },
      "ExecutableCode": {
        "description": "Code generated by the model that is meant to be executed, and the result returned to the model. Only generated when using the `CodeExecution` tool, in which the code will be automatically executed, and a corresponding `CodeExecutionResult` will also be generated.",
        "x-discovery-id": "ExecutableCode",
        "type": "object",
        "properties": {
          "id": {
            "description": "Optional. Unique identifier of the `ExecutableCode` part. The server returns the `CodeExecutionResult` with the matching `id`.",
            "type": "string"
          },
          "language": {
            "description": "Required. Programming language of the `code`.",
            "type": "string",
            "enum": [
              "LANGUAGE_UNSPECIFIED",
              "PYTHON"
            ],
            "x-enumDescriptions": [
              "Unspecified language. This value should not be used.",
              "Python >= 3.10, with numpy and simpy available. Python is the default language."
            ]
          },
          "code": {
            "description": "Required. The code to be executed.",
            "type": "string"
          }
        }
      },
      "FileData": {
        "description": "URI based data.",
        "x-discovery-id": "FileData",
        "type": "object",
        "properties": {
          "mimeType": {
            "description": "Optional. The IANA standard MIME type of the source data.",
            "type": "string"
          },
          "fileUri": {
            "description": "Required. URI.",
            "type": "string"
          }
        }
      },
      "FileSearch": {
        "description": "The FileSearch tool that retrieves knowledge from Semantic Retrieval corpora. Files are imported to Semantic Retrieval corpora using the ImportFile API.",
        "x-discovery-id": "FileSearch",
        "type": "object",
        "properties": {
          "topK": {
            "description": "Optional. The number of semantic retrieval chunks to retrieve.",
            "type": "integer",
            "format": "int32"
          },
          "fileSearchStoreNames": {
            "description": "Required. The names of the file_search_stores to retrieve from. Example: `fileSearchStores/my-file-search-store-123`",
            "type": "array",
            "items": {
              "type": "string"
            }
          },
          "metadataFilter": {
            "description": "Optional. Metadata filter to apply to the semantic retrieval documents and chunks.",
            "type": "string"
          }
        }
      },
      "FunctionCall": {
        "description": "A predicted `FunctionCall` returned from the model that contains a string representing the `FunctionDeclaration.name` with the arguments and their values.",
        "x-discovery-id": "FunctionCall",
        "type": "object",
        "properties": {
          "id": {
            "description": "Optional. Unique identifier of the function call. If populated, the client to execute the `function_call` and return the response with the matching `id`.",
            "type": "string"
          },
          "args": {
            "description": "Optional. The function parameters and values in JSON object format.",
            "type": "object",
            "additionalProperties": {
              "description": "Properties of the object."
            }
          },
          "name": {
            "description": "Required. The name of the function to call. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 128.",
            "type": "string"
          }
        }
      },
      "FunctionCallingConfig": {
        "description": "Configuration for specifying function calling behavior.",
        "x-discovery-id": "FunctionCallingConfig",
        "type": "object",
        "properties": {
          "mode": {
            "description": "Optional. Specifies the mode in which function calling should execute. If unspecified, the default value will be set to AUTO.",
            "type": "string",
            "enum": [
              "MODE_UNSPECIFIED",
              "AUTO",
              "ANY",
              "NONE",
              "VALIDATED"
            ],
            "x-enumDescriptions": [
              "Unspecified function calling mode. This value should not be used.",
              "Default model behavior, model decides to predict either a function call or a natural language response.",
              "Model is constrained to always predicting a function call only. If \"allowed_function_names\" are set, the predicted function call will be limited to any one of \"allowed_function_names\", else the predicted function call will be any one of the provided \"function_declarations\".",
              "Model will not predict any function call. Model behavior is same as when not passing any function declarations.",
              "Model decides to predict either a function call or a natural language response, but will validate function calls with constrained decoding. If \"allowed_function_names\" are set, the predicted function call will be limited to any one of \"allowed_function_names\", else the predicted function call will be any one of the provided \"function_declarations\"."
            ]
          },
          "allowedFunctionNames": {
            "description": "Optional. A set of function names that, when provided, limits the functions the model will call. This should only be set when the Mode is ANY or VALIDATED. Function names should match [FunctionDeclaration.name]. When set, model will predict a function call from only allowed function names.",
            "type": "array",
            "items": {
              "type": "string"
            }
          }
        }
      },
      "FunctionDeclaration": {
        "description": "Structured representation of a function declaration as defined by the [OpenAPI 3.03 specification](https://spec.openapis.org/oas/v3.0.3). Included in this declaration are the function name and parameters. This FunctionDeclaration is a representation of a block of code that can be used as a `Tool` by the model and executed by the client.",
        "x-discovery-id": "FunctionDeclaration",
        "type": "object",
        "properties": {
          "description": {
            "description": "Required. A brief description of the function.",
            "type": "string"
          },
          "parameters": {
            "$ref": "#/components/schemas/Schema"
          },
          "parametersJsonSchema": {
            "description": "Optional. Describes the parameters to the function in JSON Schema format. The schema must describe an object where the properties are the parameters to the function. For example: ``` { \"type\": \"object\", \"properties\": { \"name\": { \"type\": \"string\" }, \"age\": { \"type\": \"integer\" } }, \"additionalProperties\": false, \"required\": [\"name\", \"age\"], \"propertyOrdering\": [\"name\", \"age\"] } ``` This field is mutually exclusive with `parameters`."
          },
          "name": {
            "description": "Required. The name of the function. Must be a-z, A-Z, 0-9, or contain underscores, colons, dots, and dashes, with a maximum length of 128.",
            "type": "string"
          },
          "behavior": {
            "description": "Optional. Specifies the function Behavior. Currently only supported by the BidiGenerateContent method.",
            "type": "string",
            "enum": [
              "UNSPECIFIED",
              "BLOCKING",
              "NON_BLOCKING"
            ],
            "x-enumDescriptions": [
              "This value is unused.",
              "If set, the system will wait to receive the function response before continuing the conversation.",
              "If set, the system will not wait to receive the function response. Instead, it will attempt to handle function responses as they become available while maintaining the conversation between the user and the model."
            ]
          },
          "response": {
            "$ref": "#/components/schemas/Schema"
          },
          "responseJsonSchema": {
            "description": "Optional. Describes the output from this function in JSON Schema format. The value specified by the schema is the response value of the function. This field is mutually exclusive with `response`."
          }
        }
      },
      "FunctionResponse": {
        "description": "The result output from a `FunctionCall` that contains a string representing the `FunctionDeclaration.name` and a structured JSON object containing any output from the function is used as context to the model. This should contain the result of a`FunctionCall` made based on model prediction.",
        "x-discovery-id": "FunctionResponse",
        "type": "object",
        "properties": {
          "willContinue": {
            "description": "Optional. Signals that function call continues, and more responses will be returned, turning the function call into a generator. Is only applicable to NON_BLOCKING function calls, is ignored otherwise. If set to false, future responses will not be considered. It is allowed to return empty `response` with `will_continue=False` to signal that the function call is finished. This may still trigger the model generation. To avoid triggering the generation and finish the function call, additionally set `scheduling` to `SILENT`.",
            "type": "boolean"
          },
          "id": {
            "description": "Optional. The identifier of the function call this response is for. Populated by the client to match the corresponding function call `id`.",
            "type": "string"
          },
          "response": {
            "description": "Required. The function response in JSON object format. Callers can use any keys of their choice that fit the function's syntax to return the function output, e.g. \"output\", \"result\", etc. In particular, if the function call failed to execute, the response can have an \"error\" key to return error details to the model. Multimedia can be included by using a subobject containing a single \"$ref\" key whose value is the `inline_data.display_name` of a `FunctionResponsePart` holding the multimedia. See https://ai.google.dev/gemini-api/docs/function-calling#multimodal.",
            "type": "object",
            "additionalProperties": {
              "description": "Properties of the object."
            }
          },
          "name": {
            "description": "Required. The name of the function to call. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 128.",
            "type": "string"
          },
          "parts": {
            "description": "Optional. Ordered `Parts` that constitute a function response. Parts may have different IANA MIME types.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/FunctionResponsePart"
            }
          },
          "scheduling": {
            "description": "Optional. Specifies how the response should be scheduled in the conversation. Only applicable to NON_BLOCKING function calls, is ignored otherwise. Defaults to WHEN_IDLE.",
            "type": "string",
            "enum": [
              "SCHEDULING_UNSPECIFIED",
              "SILENT",
              "WHEN_IDLE",
              "INTERRUPT"
            ],
            "x-enumDescriptions": [
              "This value is unused.",
              "Only add the result to the conversation context, do not interrupt or trigger generation.",
              "Add the result to the conversation context, and prompt to generate output without interrupting ongoing generation.",
              "Add the result to the conversation context, interrupt ongoing generation and prompt to generate output."
            ]
          }
        }
      },
      "FunctionResponseBlob": {
        "description": "Raw media bytes for function response. Text should not be sent as raw bytes, use the 'FunctionResponse.response' field.",
        "x-discovery-id": "FunctionResponseBlob",
        "type": "object",
        "properties": {
          "mimeType": {
            "description": "The IANA standard MIME type of the source data. Examples: - image/png - image/jpeg If an unsupported MIME type is provided, an error will be returned. For a complete list of supported types, see [Supported file formats](https://ai.google.dev/gemini-api/docs/prompting_with_media#supported_file_formats).",
            "type": "string"
          },
          "data": {
            "description": "Raw bytes for media formats.",
            "type": "string",
            "format": "byte"
          }
        }
      },
      "FunctionResponsePart": {
        "description": "A datatype containing media that is part of a `FunctionResponse` message. A `FunctionResponsePart` consists of data which has an associated datatype. A `FunctionResponsePart` can only contain one of the accepted types in `FunctionResponsePart.data`. A `FunctionResponsePart` must have a fixed IANA MIME type identifying the type and subtype of the media if the `inline_data` field is filled with raw bytes.",
        "x-discovery-id": "FunctionResponsePart",
        "type": "object",
        "properties": {
          "inlineData": {
            "$ref": "#/components/schemas/FunctionResponseBlob"
          }
        }
      },
      "GenerateContentRequest": {
        "description": "Request to generate a completion from the model.",
        "x-discovery-id": "GenerateContentRequest",
        "type": "object",
        "properties": {
          "model": {
            "description": "Required. The name of the `Model` to use for generating the completion. Format: `models/{model}`.",
            "type": "string"
          },
          "tools": {
            "description": "Optional. A list of `Tools` the `Model` may use to generate the next response. A `Tool` is a piece of code that enables the system to interact with external systems to perform an action, or set of actions, outside of knowledge and scope of the `Model`. Supported `Tool`s are `Function` and `code_execution`. Refer to the [Function calling](https://ai.google.dev/gemini-api/docs/function-calling) and the [Code execution](https://ai.google.dev/gemini-api/docs/code-execution) guides to learn more.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Tool"
            }
          },
          "toolConfig": {
            "$ref": "#/components/schemas/ToolConfig"
          },
          "generationConfig": {
            "$ref": "#/components/schemas/GenerationConfig"
          },
          "contents": {
            "description": "Required. The content of the current conversation with the model. For single-turn queries, this is a single instance. For multi-turn queries like [chat](https://ai.google.dev/gemini-api/docs/text-generation#chat), this is a repeated field that contains the conversation history and the latest request.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Content"
            }
          },
          "cachedContent": {
            "description": "Optional. The name of the content [cached](https://ai.google.dev/gemini-api/docs/caching) to use as context to serve the prediction. Format: `cachedContents/{cachedContent}`",
            "type": "string"
          },
          "safetySettings": {
            "description": "Optional. A list of unique `SafetySetting` instances for blocking unsafe content. This will be enforced on the `GenerateContentRequest.contents` and `GenerateContentResponse.candidates`. There should not be more than one setting for each `SafetyCategory` type. The API will block any contents and responses that fail to meet the thresholds set by these settings. This list overrides the default settings for each `SafetyCategory` specified in the safety_settings. If there is no `SafetySetting` for a given `SafetyCategory` provided in the list, the API will use the default safety setting for that category. Harm categories HARM_CATEGORY_HATE_SPEECH, HARM_CATEGORY_SEXUALLY_EXPLICIT, HARM_CATEGORY_DANGEROUS_CONTENT, HARM_CATEGORY_HARASSMENT, HARM_CATEGORY_CIVIC_INTEGRITY are supported. Refer to the [guide](https://ai.google.dev/gemini-api/docs/safety-settings) for detailed information on available safety settings. Also refer to the [Safety guidance](https://ai.google.dev/gemini-api/docs/safety-guidance) to learn how to incorporate safety considerations in your AI applications.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SafetySetting"
            }
          },
          "serviceTier": {
            "description": "Optional. The service tier of the request.",
            "type": "string",
            "enum": [
              "unspecified",
              "standard",
              "flex",
              "priority"
            ],
            "x-enumDescriptions": [
              "Default service tier, which is standard.",
              "Standard service tier.",
              "Flex service tier.",
              "Priority service tier."
            ]
          },
          "systemInstruction": {
            "$ref": "#/components/schemas/Content"
          },
          "store": {
            "description": "Optional. Configures the logging behavior for a given request. If set, it takes precedence over the project-level logging config.",
            "type": "boolean"
          }
        }
      },
      "GenerateContentResponse": {
        "description": "Response from the model supporting multiple candidate responses. Safety ratings and content filtering are reported for both prompt in `GenerateContentResponse.prompt_feedback` and for each candidate in `finish_reason` and in `safety_ratings`. The API: - Returns either all requested candidates or none of them - Returns no candidates at all only if there was something wrong with the prompt (check `prompt_feedback`) - Reports feedback on each candidate in `finish_reason` and `safety_ratings`.",
        "x-discovery-id": "GenerateContentResponse",
        "type": "object",
        "properties": {
          "promptFeedback": {
            "$ref": "#/components/schemas/PromptFeedback"
          },
          "responseId": {
            "description": "Output only. response_id is used to identify each response.",
            "readOnly": true,
            "type": "string"
          },
          "modelStatus": {
            "$ref": "#/components/schemas/ModelStatus"
          },
          "modelVersion": {
            "description": "Output only. The model version used to generate the response.",
            "readOnly": true,
            "type": "string"
          },
          "usageMetadata": {
            "$ref": "#/components/schemas/UsageMetadata"
          },
          "candidates": {
            "description": "Candidate responses from the model.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Candidate"
            }
          }
        }
      },
      "GenerationConfig": {
        "description": "Configuration options for model generation and outputs. Not all parameters are configurable for every model.",
        "x-discovery-id": "GenerationConfig",
        "type": "object",
        "properties": {
          "mediaResolution": {
            "description": "Optional. If specified, the media resolution specified will be used.",
            "type": "string",
            "enum": [
              "MEDIA_RESOLUTION_UNSPECIFIED",
              "MEDIA_RESOLUTION_LOW",
              "MEDIA_RESOLUTION_MEDIUM",
              "MEDIA_RESOLUTION_HIGH"
            ],
            "x-enumDescriptions": [
              "Media resolution has not been set.",
              "Media resolution set to low (64 tokens).",
              "Media resolution set to medium (256 tokens).",
              "Media resolution set to high (zoomed reframing with 256 tokens)."
            ]
          },
          "stopSequences": {
            "description": "Optional. The set of character sequences (up to 5) that will stop output generation. If specified, the API will stop at the first appearance of a `stop_sequence`. The stop sequence will not be included as part of the response.",
            "type": "array",
            "items": {
              "type": "string"
            }
          },
          "_responseJsonSchema": {
            "description": "Optional. Output schema of the generated response. This is an alternative to `response_schema` that accepts [JSON Schema](https://json-schema.org/). If set, `response_schema` must be omitted, but `response_mime_type` is required. While the full JSON Schema may be sent, not all features are supported. Specifically, only the following properties are supported: - `$id` - `$defs` - `$ref` - `$anchor` - `type` - `format` - `title` - `description` - `enum` (for strings and numbers) - `items` - `prefixItems` - `minItems` - `maxItems` - `minimum` - `maximum` - `anyOf` - `oneOf` (interpreted the same as `anyOf`) - `properties` - `additionalProperties` - `required` The non-standard `propertyOrdering` property may also be set. Cyclic references are unrolled to a limited degree and, as such, may only be used within non-required properties. (Nullable properties are not sufficient.) If `$ref` is set on a sub-schema, no other properties, except for than those starting as a `$`, may be set."
          },
          "speechConfig": {
            "$ref": "#/components/schemas/SpeechConfig"
          },
          "topP": {
            "description": "Optional. The maximum cumulative probability of tokens to consider when sampling. The model uses combined Top-k and Top-p (nucleus) sampling. Tokens are sorted based on their assigned probabilities so that only the most likely tokens are considered. Top-k sampling directly limits the maximum number of tokens to consider, while Nucleus sampling limits the number of tokens based on the cumulative probability. Note: The default value varies by `Model` and is specified by the`Model.top_p` attribute returned from the `getModel` function. An empty `top_k` attribute indicates that the model doesn't apply top-k sampling and doesn't allow setting `top_k` on requests.",
            "type": "number",
            "format": "float"
          },
          "imageConfig": {
            "$ref": "#/components/schemas/ImageConfig"
          },
          "temperature": {
            "description": "Optional. Controls the randomness of the output. Note: The default value varies by model, see the `Model.temperature` attribute of the `Model` returned from the `getModel` function. Values can range from [0.0, 2.0].",
            "type": "number",
            "format": "float"
          },
          "maxOutputTokens": {
            "description": "Optional. The maximum number of tokens to include in a response candidate. Note: The default value varies by model, see the `Model.output_token_limit` attribute of the `Model` returned from the `getModel` function.",
            "type": "integer",
            "format": "int32"
          },
          "enableEnhancedCivicAnswers": {
            "description": "Optional. Enables enhanced civic answers. It may not be available for all models.",
            "type": "boolean"
          },
          "topK": {
            "description": "Optional. The maximum number of tokens to consider when sampling. Gemini models use Top-p (nucleus) sampling or a combination of Top-k and nucleus sampling. Top-k sampling considers the set of `top_k` most probable tokens. Models running with nucleus sampling don't allow top_k setting. Note: The default value varies by `Model` and is specified by the`Model.top_p` attribute returned from the `getModel` function. An empty `top_k` attribute indicates that the model doesn't apply top-k sampling and doesn't allow setting `top_k` on requests.",
            "type": "integer",
            "format": "int32"
          },
          "responseFormat": {
            "$ref": "#/components/schemas/ResponseFormatConfig"
          },
          "translationConfig": {
            "$ref": "#/components/schemas/TranslationConfig"
          },
          "presencePenalty": {
            "description": "Optional. Presence penalty applied to the next token's logprobs if the token has already been seen in the response. This penalty is binary on/off and not dependant on the number of times the token is used (after the first). Use frequency_penalty for a penalty that increases with each use. A positive penalty will discourage the use of tokens that have already been used in the response, increasing the vocabulary. A negative penalty will encourage the use of tokens that have already been used in the response, decreasing the vocabulary.",
            "type": "number",
            "format": "float"
          },
          "responseLogprobs": {
            "description": "Optional. If true, export the logprobs results in response.",
            "type": "boolean"
          },
          "candidateCount": {
            "description": "Optional. Number of generated responses to return. If unset, this will default to 1. Please note that this doesn't work for previous generation models (Gemini 1.0 family)",
            "type": "integer",
            "format": "int32"
          },
          "logprobs": {
            "description": "Optional. Only valid if response_logprobs=True. This sets the number of top logprobs, including the chosen candidate, to return at each decoding step in the Candidate.logprobs_result. The number must be in the range of [0, 20].",
            "type": "integer",
            "format": "int32"
          },
          "thinkingConfig": {
            "$ref": "#/components/schemas/ThinkingConfig"
          },
          "responseJsonSchema": {
            "description": "Optional. An internal detail. Use `responseJsonSchema` rather than this field."
          },
          "frequencyPenalty": {
            "description": "Optional. Frequency penalty applied to the next token's logprobs, multiplied by the number of times each token has been seen in the respponse so far. A positive penalty will discourage the use of tokens that have already been used, proportional to the number of times the token has been used: The more a token is used, the more difficult it is for the model to use that token again increasing the vocabulary of responses. Caution: A _negative_ penalty will encourage the model to reuse tokens proportional to the number of times the token has been used. Small negative values will reduce the vocabulary of a response. Larger negative values will cause the model to start repeating a common token until it hits the max_output_tokens limit.",
            "type": "number",
            "format": "float"
          },
          "seed": {
            "description": "Optional. Seed used in decoding. If not set, the request uses a randomly generated seed.",
            "type": "integer",
            "format": "int32"
          },
          "responseModalities": {
            "description": "Optional. The requested modalities of the response. Represents the set of modalities that the model can return, and should be expected in the response. This is an exact match to the modalities of the response. A model may have multiple combinations of supported modalities. If the requested modalities do not match any of the supported combinations, an error will be returned. An empty list is equivalent to requesting only text.",
            "type": "array",
            "items": {
              "type": "string",
              "enum": [
                "MODALITY_UNSPECIFIED",
                "TEXT",
                "IMAGE",
                "AUDIO"
              ],
              "x-enumDescriptions": [
                "Default value.",
                "Indicates the model should return text.",
                "Indicates the model should return images.",
                "Indicates the model should return audio."
              ]
            }
          },
          "responseMimeType": {
            "description": "Optional. MIME type of the generated candidate text. Supported MIME types are: `text/plain`: (default) Text output. `application/json`: JSON response in the response candidates. `text/x.enum`: ENUM as a string response in the response candidates. Refer to the [docs](https://ai.google.dev/gemini-api/docs/prompting_with_media#plain_text_formats) for a list of all supported text MIME types.",
            "type": "string"
          },
          "responseSchema": {
            "$ref": "#/components/schemas/Schema"
          }
        }
      },
      "GoogleAiGenerativelanguageV1betaGroundingSupport": {
        "description": "Grounding support.",
        "x-discovery-id": "GoogleAiGenerativelanguageV1betaGroundingSupport",
        "type": "object",
        "properties": {
          "renderedParts": {
            "description": "Output only. Indices into the `parts` field of the candidate's content. These indices specify which rendered parts are associated with this support source.",
            "readOnly": true,
            "type": "array",
            "items": {
              "type": "integer",
              "format": "int32"
            }
          },
          "groundingChunkIndices": {
            "description": "Optional. A list of indices (into 'grounding_chunk' in `response.candidate.grounding_metadata`) specifying the citations associated with the claim. For instance [1,3,4] means that grounding_chunk[1], grounding_chunk[3], grounding_chunk[4] are the retrieved content attributed to the claim. If the response is streaming, the grounding_chunk_indices refer to the indices across all responses. It is the client's responsibility to accumulate the grounding chunks from all responses (while maintaining the same order).",
            "type": "array",
            "items": {
              "type": "integer",
              "format": "int32"
            }
          },
          "segment": {
            "$ref": "#/components/schemas/GoogleAiGenerativelanguageV1betaSegment"
          },
          "confidenceScores": {
            "description": "Optional. Confidence score of the support references. Ranges from 0 to 1. 1 is the most confident. This list must have the same size as the grounding_chunk_indices.",
            "type": "array",
            "items": {
              "type": "number",
              "format": "float"
            }
          }
        }
      },
      "GoogleAiGenerativelanguageV1betaSegment": {
        "description": "Segment of the content.",
        "x-discovery-id": "GoogleAiGenerativelanguageV1betaSegment",
        "type": "object",
        "properties": {
          "endIndex": {
            "description": "End index in the given Part, measured in bytes. Offset from the start of the Part, exclusive, starting at zero.",
            "type": "integer",
            "format": "int32"
          },
          "startIndex": {
            "description": "Start index in the given Part, measured in bytes. Offset from the start of the Part, inclusive, starting at zero.",
            "type": "integer",
            "format": "int32"
          },
          "text": {
            "description": "The text corresponding to the segment from the response.",
            "type": "string"
          },
          "partIndex": {
            "description": "The index of a Part object within its parent Content object.",
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "GoogleMaps": {
        "description": "The GoogleMaps Tool that provides geospatial context for the user's query.",
        "x-discovery-id": "GoogleMaps",
        "type": "object",
        "properties": {
          "enableWidget": {
            "description": "Optional. Whether to return a widget context token in the GroundingMetadata of the response. Developers can use the widget context token to render a Google Maps widget with geospatial context related to the places that the model references in the response.",
            "type": "boolean"
          }
        }
      },
      "GoogleSearch": {
        "description": "GoogleSearch tool type. Tool to support Google Search in Model. Powered by Google.",
        "x-discovery-id": "GoogleSearch",
        "type": "object",
        "properties": {
          "timeRangeFilter": {
            "$ref": "#/components/schemas/Interval"
          },
          "searchTypes": {
            "$ref": "#/components/schemas/SearchTypes"
          }
        }
      },
      "GoogleSearchRetrieval": {
        "description": "Tool to retrieve public web data for grounding, powered by Google.",
        "x-discovery-id": "GoogleSearchRetrieval",
        "type": "object",
        "properties": {
          "dynamicRetrievalConfig": {
            "$ref": "#/components/schemas/DynamicRetrievalConfig"
          }
        }
      },
      "GroundingAttribution": {
        "description": "Attribution for a source that contributed to an answer.",
        "x-discovery-id": "GroundingAttribution",
        "type": "object",
        "properties": {
          "sourceId": {
            "$ref": "#/components/schemas/AttributionSourceId"
          },
          "content": {
            "$ref": "#/components/schemas/Content"
          }
        }
      },
      "GroundingChunk": {
        "description": "A `GroundingChunk` represents a segment of supporting evidence that grounds the model's response. It can be a chunk from the web, a retrieved context from a file, or information from Google Maps.",
        "x-discovery-id": "GroundingChunk",
        "type": "object",
        "properties": {
          "image": {
            "$ref": "#/components/schemas/Image"
          },
          "retrievedContext": {
            "$ref": "#/components/schemas/RetrievedContext"
          },
          "maps": {
            "$ref": "#/components/schemas/Maps"
          },
          "web": {
            "$ref": "#/components/schemas/Web"
          }
        }
      },
      "GroundingChunkCustomMetadata": {
        "description": "User provided metadata about the GroundingFact.",
        "x-discovery-id": "GroundingChunkCustomMetadata",
        "type": "object",
        "properties": {
          "key": {
            "description": "The key of the metadata.",
            "type": "string"
          },
          "stringValue": {
            "description": "Optional. The string value of the metadata.",
            "type": "string"
          },
          "stringListValue": {
            "$ref": "#/components/schemas/GroundingChunkStringList"
          },
          "numericValue": {
            "description": "Optional. The numeric value of the metadata. The expected range for this value depends on the specific `key` used.",
            "type": "number",
            "format": "float"
          }
        }
      },
      "GroundingChunkStringList": {
        "description": "A list of string values.",
        "x-discovery-id": "GroundingChunkStringList",
        "type": "object",
        "properties": {
          "values": {
            "description": "The string values of the list.",
            "type": "array",
            "items": {
              "type": "string"
            }
          }
        }
      },
      "GroundingMetadata": {
        "description": "Metadata returned to client when grounding is enabled.",
        "x-discovery-id": "GroundingMetadata",
        "type": "object",
        "properties": {
          "searchEntryPoint": {
            "$ref": "#/components/schemas/SearchEntryPoint"
          },
          "webSearchQueries": {
            "description": "Web search queries for the following-up web search.",
            "type": "array",
            "items": {
              "type": "string"
            }
          },
          "googleMapsWidgetContextToken": {
            "description": "Optional. Resource name of the Google Maps widget context token that can be used with the PlacesContextElement widget in order to render contextual data. Only populated in the case that grounding with Google Maps is enabled.",
            "type": "string"
          },
          "imageSearchQueries": {
            "description": "Image search queries used for grounding.",
            "type": "array",
            "items": {
              "type": "string"
            }
          },
          "groundingChunks": {
            "description": "List of supporting references retrieved from specified grounding source. When streaming, this only contains the grounding chunks that have not been included in the grounding metadata of previous responses.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/GroundingChunk"
            }
          },
          "groundingSupports": {
            "description": "List of grounding support.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/GoogleAiGenerativelanguageV1betaGroundingSupport"
            }
          },
          "retrievalMetadata": {
            "$ref": "#/components/schemas/RetrievalMetadata"
          }
        }
      },
      "GroundingPassageId": {
        "description": "Identifier for a part within a `GroundingPassage`.",
        "x-discovery-id": "GroundingPassageId",
        "type": "object",
        "properties": {
          "passageId": {
            "description": "Output only. ID of the passage matching the `GenerateAnswerRequest`'s `GroundingPassage.id`.",
            "readOnly": true,
            "type": "string"
          },
          "partIndex": {
            "description": "Output only. Index of the part within the `GenerateAnswerRequest`'s `GroundingPassage.content`.",
            "readOnly": true,
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "Image": {
        "description": "Chunk from image search.",
        "x-discovery-id": "Image",
        "type": "object",
        "properties": {
          "imageUri": {
            "description": "The image asset URL.",
            "type": "string"
          },
          "sourceUri": {
            "description": "The web page URI for attribution.",
            "type": "string"
          },
          "title": {
            "description": "The title of the web page that the image is from.",
            "type": "string"
          },
          "domain": {
            "description": "The root domain of the web page that the image is from, e.g. \"example.com\".",
            "type": "string"
          }
        }
      },
      "ImageConfig": {
        "description": "Config for image generation features.",
        "x-discovery-id": "ImageConfig",
        "type": "object",
        "properties": {
          "aspectRatio": {
            "description": "Optional. The aspect ratio of the image to generate. Supported aspect ratios: `1:1`, `1:4`, `4:1`, `1:8`, `8:1`, `2:3`, `3:2`, `3:4`, `4:3`, `4:5`, `5:4`, `9:16`, `16:9`, or `21:9`. If not specified, the model will choose a default aspect ratio based on any reference images provided.",
            "type": "string"
          },
          "imageSize": {
            "description": "Optional. Specifies the size of generated images. Supported values are `512`, `1K`, `2K`, `4K`. If not specified, the model will use default value `1K`.",
            "type": "string"
          }
        }
      },
      "ImageResponseFormat": {
        "description": "Configuration for image output format.",
        "x-discovery-id": "ImageResponseFormat",
        "type": "object",
        "properties": {
          "imageSize": {
            "description": "Optional. The size of the image output.",
            "type": "string",
            "enum": [
              "IMAGE_SIZE_UNSPECIFIED",
              "IMAGE_SIZE_FIVE_TWELVE",
              "IMAGE_SIZE_ONE_K",
              "IMAGE_SIZE_TWO_K",
              "IMAGE_SIZE_FOUR_K"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "512px image size.",
              "1K image size.",
              "2K image size.",
              "4K image size."
            ]
          },
          "mimeType": {
            "description": "Optional. The MIME type of the image output.",
            "type": "string",
            "enum": [
              "MIME_TYPE_UNSPECIFIED",
              "IMAGE_JPEG"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "JPEG image format."
            ]
          },
          "aspectRatio": {
            "description": "Optional. The aspect ratio for the image output.",
            "type": "string",
            "enum": [
              "ASPECT_RATIO_UNSPECIFIED",
              "ASPECT_RATIO_ONE_BY_ONE",
              "ASPECT_RATIO_TWO_BY_THREE",
              "ASPECT_RATIO_THREE_BY_TWO",
              "ASPECT_RATIO_THREE_BY_FOUR",
              "ASPECT_RATIO_FOUR_BY_THREE",
              "ASPECT_RATIO_FOUR_BY_FIVE",
              "ASPECT_RATIO_FIVE_BY_FOUR",
              "ASPECT_RATIO_NINE_BY_SIXTEEN",
              "ASPECT_RATIO_SIXTEEN_BY_NINE",
              "ASPECT_RATIO_TWENTY_ONE_BY_NINE",
              "ASPECT_RATIO_ONE_BY_EIGHT",
              "ASPECT_RATIO_EIGHT_BY_ONE",
              "ASPECT_RATIO_ONE_BY_FOUR",
              "ASPECT_RATIO_FOUR_BY_ONE"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "1:1 aspect ratio.",
              "2:3 aspect ratio.",
              "3:2 aspect ratio.",
              "3:4 aspect ratio.",
              "4:3 aspect ratio.",
              "4:5 aspect ratio.",
              "5:4 aspect ratio.",
              "9:16 aspect ratio.",
              "16:9 aspect ratio.",
              "21:9 aspect ratio.",
              "1:8 aspect ratio.",
              "8:1 aspect ratio.",
              "1:4 aspect ratio.",
              "4:1 aspect ratio."
            ]
          },
          "delivery": {
            "description": "Optional. The delivery mode for the image output.",
            "type": "string",
            "enum": [
              "DELIVERY_UNSPECIFIED",
              "INLINE",
              "URI"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "Image data is returned inline in the response.",
              "Image data is returned as a URI."
            ]
          }
        }
      },
      "ImageSearch": {
        "description": "Image search for grounding and related configurations.",
        "x-discovery-id": "ImageSearch",
        "type": "object",
        "properties": {}
      },
      "Interval": {
        "description": "Represents a time interval, encoded as a Timestamp start (inclusive) and a Timestamp end (exclusive). The start must be less than or equal to the end. When the start equals the end, the interval is empty (matches no time). When both start and end are unspecified, the interval matches any time.",
        "x-discovery-id": "Interval",
        "type": "object",
        "properties": {
          "endTime": {
            "description": "Optional. Exclusive end of the interval. If specified, a Timestamp matching this interval will have to be before the end.",
            "type": "string",
            "format": "google-datetime"
          },
          "startTime": {
            "description": "Optional. Inclusive start of the interval. If specified, a Timestamp matching this interval will have to be the same or after the start.",
            "type": "string",
            "format": "google-datetime"
          }
        }
      },
      "LatLng": {
        "description": "An object that represents a latitude/longitude pair. This is expressed as a pair of doubles to represent degrees latitude and degrees longitude. Unless specified otherwise, this object must conform to the WGS84 standard. Values must be within normalized ranges.",
        "x-discovery-id": "LatLng",
        "type": "object",
        "properties": {
          "latitude": {
            "description": "The latitude in degrees. It must be in the range [-90.0, +90.0].",
            "type": "number",
            "format": "double"
          },
          "longitude": {
            "description": "The longitude in degrees. It must be in the range [-180.0, +180.0].",
            "type": "number",
            "format": "double"
          }
        }
      },
      "LogprobsResult": {
        "description": "Logprobs Result",
        "x-discovery-id": "LogprobsResult",
        "type": "object",
        "properties": {
          "logProbabilitySum": {
            "description": "Sum of log probabilities for all tokens.",
            "type": "number",
            "format": "float"
          },
          "chosenCandidates": {
            "description": "Length = total number of decoding steps. The chosen candidates may or may not be in top_candidates.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/LogprobsResultCandidate"
            }
          },
          "topCandidates": {
            "description": "Length = total number of decoding steps.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/TopCandidates"
            }
          }
        }
      },
      "LogprobsResultCandidate": {
        "description": "Candidate for the logprobs token and score.",
        "x-discovery-id": "LogprobsResultCandidate",
        "type": "object",
        "properties": {
          "token": {
            "description": "The candidate’s token string value.",
            "type": "string"
          },
          "logProbability": {
            "description": "The candidate's log probability.",
            "type": "number",
            "format": "float"
          },
          "tokenId": {
            "description": "The candidate’s token id value.",
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "Maps": {
        "description": "A grounding chunk from Google Maps. A Maps chunk corresponds to a single place.",
        "x-discovery-id": "Maps",
        "type": "object",
        "properties": {
          "placeId": {
            "description": "The ID of the place, in `places/{place_id}` format. A user can use this ID to look up that place.",
            "type": "string"
          },
          "uri": {
            "description": "URI reference of the place.",
            "type": "string"
          },
          "title": {
            "description": "Title of the place.",
            "type": "string"
          },
          "text": {
            "description": "Text description of the place answer.",
            "type": "string"
          },
          "placeAnswerSources": {
            "$ref": "#/components/schemas/PlaceAnswerSources"
          }
        }
      },
      "McpServer": {
        "description": "A MCPServer is a server that can be called by the model to perform actions. It is a server that implements the MCP protocol. Next ID: 6",
        "x-discovery-id": "McpServer",
        "type": "object",
        "properties": {
          "streamableHttpTransport": {
            "$ref": "#/components/schemas/StreamableHttpTransport"
          },
          "name": {
            "description": "The name of the MCPServer.",
            "type": "string"
          }
        }
      },
      "MediaResolution": {
        "description": "Media resolution for tokenization.",
        "x-discovery-missing-schema": true,
        "type": "object",
        "properties": {
          "level": {
            "description": "The tokenization quality used for the given media.",
            "type": "string",
            "enum": [
              "MEDIA_RESOLUTION_UNSPECIFIED",
              "MEDIA_RESOLUTION_LOW",
              "MEDIA_RESOLUTION_MEDIUM",
              "MEDIA_RESOLUTION_HIGH",
              "MEDIA_RESOLUTION_ULTRA_HIGH"
            ],
            "x-enumDescriptions": [
              "Media resolution has not been set.",
              "Media resolution set to low.",
              "Media resolution set to medium.",
              "Media resolution set to high.",
              "Media resolution set to ultra high."
            ]
          }
        }
      },
      "ModalityTokenCount": {
        "description": "Represents token counting info for a single modality.",
        "x-discovery-id": "ModalityTokenCount",
        "type": "object",
        "properties": {
          "modality": {
            "description": "The modality associated with this token count.",
            "type": "string",
            "enum": [
              "MODALITY_UNSPECIFIED",
              "TEXT",
              "IMAGE",
              "VIDEO",
              "AUDIO",
              "DOCUMENT"
            ],
            "x-enumDescriptions": [
              "Unspecified modality.",
              "Plain text.",
              "Image.",
              "Video.",
              "Audio.",
              "Document, e.g. PDF."
            ]
          },
          "tokenCount": {
            "description": "Number of tokens.",
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "ModelStatus": {
        "description": "The status of the underlying model. This is used to indicate the stage of the underlying model and the retirement time if applicable.",
        "x-discovery-id": "ModelStatus",
        "type": "object",
        "properties": {
          "modelStage": {
            "description": "The stage of the underlying model.",
            "type": "string",
            "enum": [
              "MODEL_STAGE_UNSPECIFIED",
              "UNSTABLE_EXPERIMENTAL",
              "EXPERIMENTAL",
              "PREVIEW",
              "STABLE",
              "LEGACY",
              "DEPRECATED",
              "RETIRED"
            ],
            "x-enumDescriptions": [
              "Unspecified model stage.",
              "The underlying model is subject to lots of tunings.",
              "Models in this stage are for experimental purposes only.",
              "Models in this stage are more mature than experimental models.",
              "Models in this stage are considered stable and ready for production use.",
              "If the model is on this stage, it means that this model is on the path to deprecation in near future. Only existing customers can use this model.",
              "Models in this stage are deprecated. These models cannot be used.",
              "Models in this stage are retired. These models cannot be used."
            ],
            "x-enumDeprecated": [
              false,
              true,
              false,
              false,
              false,
              false,
              true,
              false
            ]
          },
          "retirementTime": {
            "description": "The time at which the model will be retired.",
            "type": "string",
            "format": "google-datetime"
          },
          "message": {
            "description": "A message explaining the model status.",
            "type": "string"
          }
        }
      },
      "MultiSpeakerVoiceConfig": {
        "description": "The configuration for the multi-speaker setup.",
        "x-discovery-id": "MultiSpeakerVoiceConfig",
        "type": "object",
        "properties": {
          "speakerVoiceConfigs": {
            "description": "Required. All the enabled speaker voices.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SpeakerVoiceConfig"
            }
          }
        }
      },
      "Part": {
        "description": "A datatype containing media that is part of a multi-part `Content` message. A `Part` consists of data which has an associated datatype. A `Part` can only contain one of the accepted types in `Part.data`. A `Part` must have a fixed IANA MIME type identifying the type and subtype of the media if the `inline_data` field is filled with raw bytes.",
        "x-discovery-id": "Part",
        "type": "object",
        "properties": {
          "inlineData": {
            "$ref": "#/components/schemas/Blob"
          },
          "videoMetadata": {
            "$ref": "#/components/schemas/VideoMetadata"
          },
          "fileData": {
            "$ref": "#/components/schemas/FileData"
          },
          "codeExecutionResult": {
            "$ref": "#/components/schemas/CodeExecutionResult"
          },
          "text": {
            "description": "Inline text.",
            "type": "string"
          },
          "partMetadata": {
            "description": "Custom metadata associated with the Part. Agents using genai.Part as content representation may need to keep track of the additional information. For example it can be name of a file/source from which the Part originates or a way to multiplex multiple Part streams.",
            "type": "object",
            "additionalProperties": {
              "description": "Properties of the object."
            }
          },
          "functionCall": {
            "$ref": "#/components/schemas/FunctionCall"
          },
          "toolResponse": {
            "$ref": "#/components/schemas/ToolResponse"
          },
          "thoughtSignature": {
            "description": "Optional. An opaque signature for the thought so it can be reused in subsequent requests.",
            "type": "string",
            "format": "byte"
          },
          "thought": {
            "description": "Optional. Indicates if the part is thought from the model.",
            "type": "boolean"
          },
          "functionResponse": {
            "$ref": "#/components/schemas/FunctionResponse"
          },
          "executableCode": {
            "$ref": "#/components/schemas/ExecutableCode"
          },
          "mediaResolution": {
            "$ref": "#/components/schemas/MediaResolution"
          },
          "toolCall": {
            "$ref": "#/components/schemas/ToolCall"
          }
        }
      },
      "PlaceAnswerSources": {
        "description": "Collection of sources that provide answers about the features of a given place in Google Maps. Each PlaceAnswerSources message corresponds to a specific place in Google Maps. The Google Maps tool used these sources in order to answer questions about features of the place (e.g: \"does Bar Foo have Wifi\" or \"is Foo Bar wheelchair accessible?\"). Currently we only support review snippets as sources.",
        "x-discovery-id": "PlaceAnswerSources",
        "type": "object",
        "properties": {
          "reviewSnippets": {
            "description": "Snippets of reviews that are used to generate answers about the features of a given place in Google Maps.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/ReviewSnippet"
            }
          }
        }
      },
      "PrebuiltVoiceConfig": {
        "description": "The configuration for the prebuilt speaker to use.",
        "x-discovery-id": "PrebuiltVoiceConfig",
        "type": "object",
        "properties": {
          "voiceName": {
            "description": "The name of the preset voice to use.",
            "type": "string"
          }
        }
      },
      "PromptFeedback": {
        "description": "A set of the feedback metadata the prompt specified in `GenerateContentRequest.content`.",
        "x-discovery-id": "PromptFeedback",
        "type": "object",
        "properties": {
          "blockReason": {
            "description": "Optional. If set, the prompt was blocked and no candidates are returned. Rephrase the prompt.",
            "type": "string",
            "enum": [
              "BLOCK_REASON_UNSPECIFIED",
              "SAFETY",
              "OTHER",
              "BLOCKLIST",
              "PROHIBITED_CONTENT",
              "IMAGE_SAFETY"
            ],
            "x-enumDescriptions": [
              "Default value. This value is unused.",
              "Prompt was blocked due to safety reasons. Inspect `safety_ratings` to understand which safety category blocked it.",
              "Prompt was blocked due to unknown reasons.",
              "Prompt was blocked due to the terms which are included from the terminology blocklist.",
              "Prompt was blocked due to prohibited content.",
              "Candidates blocked due to unsafe image generation content."
            ]
          },
          "safetyRatings": {
            "description": "Ratings for safety of the prompt. There is at most one rating per category.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/SafetyRating"
            }
          }
        }
      },
      "ResponseFormatConfig": {
        "description": "Configuration for the response output format. This is a flat object where each optional sub-field configures a specific output modality.",
        "x-discovery-id": "ResponseFormatConfig",
        "type": "object",
        "properties": {
          "text": {
            "$ref": "#/components/schemas/TextResponseFormat"
          },
          "image": {
            "$ref": "#/components/schemas/ImageResponseFormat"
          },
          "audio": {
            "$ref": "#/components/schemas/AudioResponseFormat"
          }
        }
      },
      "RetrievalConfig": {
        "description": "Retrieval config.",
        "x-discovery-id": "RetrievalConfig",
        "type": "object",
        "properties": {
          "latLng": {
            "$ref": "#/components/schemas/LatLng"
          },
          "languageCode": {
            "description": "Optional. The language code of the user. Language code for content. Use language tags defined by [BCP47](https://www.rfc-editor.org/rfc/bcp/bcp47.txt).",
            "type": "string"
          }
        }
      },
      "RetrievalMetadata": {
        "description": "Metadata related to retrieval in the grounding flow.",
        "x-discovery-id": "RetrievalMetadata",
        "type": "object",
        "properties": {
          "googleSearchDynamicRetrievalScore": {
            "description": "Optional. Score indicating how likely information from google search could help answer the prompt. The score is in the range [0, 1], where 0 is the least likely and 1 is the most likely. This score is only populated when google search grounding and dynamic retrieval is enabled. It will be compared to the threshold to determine whether to trigger google search.",
            "type": "number",
            "format": "float"
          }
        }
      },
      "RetrievedContext": {
        "description": "Chunk from context retrieved by the file search tool.",
        "x-discovery-id": "RetrievedContext",
        "type": "object",
        "properties": {
          "pageNumber": {
            "description": "Optional. Page number of the retrieved context, if applicable.",
            "type": "integer",
            "format": "int32"
          },
          "mediaId": {
            "description": "Optional. The media blob resource name for multimodal file search results. Format: fileSearchStores/{file_search_store_id}/media/{blob_id}",
            "type": "string"
          },
          "fileSearchStore": {
            "description": "Optional. Name of the `FileSearchStore` containing the document. Example: `fileSearchStores/123`",
            "type": "string"
          },
          "customMetadata": {
            "description": "Optional. User-provided metadata about the retrieved context.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/GroundingChunkCustomMetadata"
            }
          },
          "uri": {
            "description": "Optional. URI reference of the semantic retrieval document.",
            "type": "string"
          },
          "title": {
            "description": "Optional. Title of the document.",
            "type": "string"
          },
          "text": {
            "description": "Optional. Text of the chunk.",
            "type": "string"
          }
        }
      },
      "ReviewSnippet": {
        "description": "Encapsulates a snippet of a user review that answers a question about the features of a specific place in Google Maps.",
        "x-discovery-id": "ReviewSnippet",
        "type": "object",
        "properties": {
          "reviewId": {
            "description": "The ID of the review snippet.",
            "type": "string"
          },
          "googleMapsUri": {
            "description": "A link that corresponds to the user review on Google Maps.",
            "type": "string"
          },
          "title": {
            "description": "Title of the review.",
            "type": "string"
          }
        }
      },
      "SafetyRating": {
        "description": "Safety rating for a piece of content. The safety rating contains the category of harm and the harm probability level in that category for a piece of content. Content is classified for safety across a number of harm categories and the probability of the harm classification is included here.",
        "x-discovery-id": "SafetyRating",
        "type": "object",
        "properties": {
          "category": {
            "description": "Required. The category for this rating.",
            "type": "string",
            "enum": [
              "HARM_CATEGORY_UNSPECIFIED",
              "HARM_CATEGORY_DEROGATORY",
              "HARM_CATEGORY_TOXICITY",
              "HARM_CATEGORY_VIOLENCE",
              "HARM_CATEGORY_SEXUAL",
              "HARM_CATEGORY_MEDICAL",
              "HARM_CATEGORY_DANGEROUS",
              "HARM_CATEGORY_HARASSMENT",
              "HARM_CATEGORY_HATE_SPEECH",
              "HARM_CATEGORY_SEXUALLY_EXPLICIT",
              "HARM_CATEGORY_DANGEROUS_CONTENT",
              "HARM_CATEGORY_CIVIC_INTEGRITY"
            ],
            "x-enumDescriptions": [
              "Category is unspecified.",
              "**PaLM** - Negative or harmful comments targeting identity and/or protected attribute.",
              "**PaLM** - Content that is rude, disrespectful, or profane.",
              "**PaLM** - Describes scenarios depicting violence against an individual or group, or general descriptions of gore.",
              "**PaLM** - Contains references to sexual acts or other lewd content.",
              "**PaLM** - Promotes unchecked medical advice.",
              "**PaLM** - Dangerous content that promotes, facilitates, or encourages harmful acts.",
              "**Gemini** - Harassment content.",
              "**Gemini** - Hate speech and content.",
              "**Gemini** - Sexually explicit content.",
              "**Gemini** - Dangerous content.",
              "**Gemini** - Content that may be used to harm civic integrity. DEPRECATED: use enable_enhanced_civic_answers instead."
            ],
            "x-enumDeprecated": [
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              true
            ]
          },
          "probability": {
            "description": "Required. The probability of harm for this content.",
            "type": "string",
            "enum": [
              "HARM_PROBABILITY_UNSPECIFIED",
              "NEGLIGIBLE",
              "LOW",
              "MEDIUM",
              "HIGH"
            ],
            "x-enumDescriptions": [
              "Probability is unspecified.",
              "Content has a negligible chance of being unsafe.",
              "Content has a low chance of being unsafe.",
              "Content has a medium chance of being unsafe.",
              "Content has a high chance of being unsafe."
            ]
          },
          "blocked": {
            "description": "Was this content blocked because of this rating?",
            "type": "boolean"
          }
        }
      },
      "SafetySetting": {
        "description": "Safety setting, affecting the safety-blocking behavior. Passing a safety setting for a category changes the allowed probability that content is blocked.",
        "x-discovery-id": "SafetySetting",
        "type": "object",
        "properties": {
          "category": {
            "description": "Required. The category for this setting.",
            "type": "string",
            "enum": [
              "HARM_CATEGORY_UNSPECIFIED",
              "HARM_CATEGORY_DEROGATORY",
              "HARM_CATEGORY_TOXICITY",
              "HARM_CATEGORY_VIOLENCE",
              "HARM_CATEGORY_SEXUAL",
              "HARM_CATEGORY_MEDICAL",
              "HARM_CATEGORY_DANGEROUS",
              "HARM_CATEGORY_HARASSMENT",
              "HARM_CATEGORY_HATE_SPEECH",
              "HARM_CATEGORY_SEXUALLY_EXPLICIT",
              "HARM_CATEGORY_DANGEROUS_CONTENT",
              "HARM_CATEGORY_CIVIC_INTEGRITY"
            ],
            "x-enumDescriptions": [
              "Category is unspecified.",
              "**PaLM** - Negative or harmful comments targeting identity and/or protected attribute.",
              "**PaLM** - Content that is rude, disrespectful, or profane.",
              "**PaLM** - Describes scenarios depicting violence against an individual or group, or general descriptions of gore.",
              "**PaLM** - Contains references to sexual acts or other lewd content.",
              "**PaLM** - Promotes unchecked medical advice.",
              "**PaLM** - Dangerous content that promotes, facilitates, or encourages harmful acts.",
              "**Gemini** - Harassment content.",
              "**Gemini** - Hate speech and content.",
              "**Gemini** - Sexually explicit content.",
              "**Gemini** - Dangerous content.",
              "**Gemini** - Content that may be used to harm civic integrity. DEPRECATED: use enable_enhanced_civic_answers instead."
            ],
            "x-enumDeprecated": [
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              false,
              true
            ]
          },
          "threshold": {
            "description": "Required. Controls the probability threshold at which harm is blocked.",
            "type": "string",
            "enum": [
              "HARM_BLOCK_THRESHOLD_UNSPECIFIED",
              "BLOCK_LOW_AND_ABOVE",
              "BLOCK_MEDIUM_AND_ABOVE",
              "BLOCK_ONLY_HIGH",
              "BLOCK_NONE",
              "OFF"
            ],
            "x-enumDescriptions": [
              "Threshold is unspecified.",
              "Content with NEGLIGIBLE will be allowed.",
              "Content with NEGLIGIBLE and LOW will be allowed.",
              "Content with NEGLIGIBLE, LOW, and MEDIUM will be allowed.",
              "All content will be allowed.",
              "Turn off the safety filter."
            ]
          }
        }
      },
      "Schema": {
        "description": "The `Schema` object allows the definition of input and output data types. These types can be objects, but also primitives and arrays. Represents a select subset of an [OpenAPI 3.0 schema object](https://spec.openapis.org/oas/v3.0.3#schema).",
        "x-discovery-id": "Schema",
        "type": "object",
        "properties": {
          "minItems": {
            "description": "Optional. Minimum number of the elements for Type.ARRAY.",
            "type": "string",
            "format": "int64"
          },
          "maximum": {
            "description": "Optional. Maximum value of the Type.INTEGER and Type.NUMBER",
            "type": "number",
            "format": "double"
          },
          "nullable": {
            "description": "Optional. Indicates if the value may be null.",
            "type": "boolean"
          },
          "default": {
            "description": "Optional. Default value of the field. Per JSON Schema, this field is intended for documentation generators and doesn't affect validation. Thus it's included here and ignored so that developers who send schemas with a `default` field don't get unknown-field errors."
          },
          "example": {
            "description": "Optional. Example of the object. Will only populated when the object is the root."
          },
          "maxLength": {
            "description": "Optional. Maximum length of the Type.STRING",
            "type": "string",
            "format": "int64"
          },
          "anyOf": {
            "description": "Optional. The value should be validated against any (one or more) of the subschemas in the list.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Schema"
            }
          },
          "enum": {
[...]
